//
//  Controller.m
//  StripToNSString
//
//  Created by KOYAMA Yoshiaki on 05/11/05.
//  Copyright 2005 KOYAMA Yoshiaki. All rights reserved.
//

#import "Controller.h"


@implementation Controller

// EBhEƂ̏
- (BOOL)windowShouldClose:(id)sender {
	[NSApp terminate:self];
    return YES;
}

- (IBAction)stripAction:(id)sender {
//	[self stripStringAction:sender];
	[self stripStringRTFAction:sender];
}

- (IBAction)stripStringAction:(id)sender {
    NSPasteboard *board = [NSPasteboard generalPasteboard];
	NSArray *array;
	NSString *type, *typeString;
	int arrayCount = 0;
	BOOL flag = NO;
	int i, tag;

	// {^ɕt^OŔf
	tag = [sender tag];

	array = [board types];
	arrayCount = [array count];

    for (i=0; i<arrayCount; i++) {
		type = [array objectAtIndex:i];
//		NSLog(@"type = %@", type);

		if (([type isEqualToString:@"NSStringPboardType"] == YES) && (flag == NO)) {
			typeString = [board stringForType:type];
//			NSLog(@"NSString = %@", typeString);

			[self pasteString:typeString];
			flag = YES;
		}
    }
}

- (IBAction)stripFileAction:(id)sender {
    NSPasteboard *board = [NSPasteboard generalPasteboard];
	NSArray *array;
	NSString *type;
	NSString *typeString;
	NSMutableString *boardMutableString;
	NSString *nodesString;
	int arrayCount = 0, nodesCount = 0;
	NSError *error = nil;
	BOOL flag = NO;
	NSXMLDocument *document;
	NSArray *nodes;
	int i;
	int tag;

	// {^ɕt^OŔf
	tag = [sender tag];

	array = [board types];
	arrayCount = [array count];

	boardMutableString = [NSMutableString string];

    for (i=0; i<arrayCount; i++) {
		type = [array objectAtIndex:i];      

//		NSLog(@"type = %@", type);

		if (([type isEqualToString:@"NSFilenamesPboardType"] == YES) && (flag == NO)) {
	
			typeString = [board stringForType:type];
//			list = [board propertyListForType:type];
//			NSLog(@"NSString = %@", list);

			document = [[NSXMLDocument alloc] initWithXMLString:typeString options:0 error:&error];
			nodes = [document nodesForXPath:@".//array/string" error:&error];
			nodesCount = [nodes count];
	
			if (nodesCount != 0) {
				for (i=0; i<nodesCount; i++) {
					nodesString = [[nodes objectAtIndex:i] stringValue];
	
					// Path{^
					if (tag == 1) {
						[boardMutableString appendFormat:@"%@\n",nodesString];
					// file{^
					} else {
						[boardMutableString appendFormat:@"%@\n",[nodesString lastPathComponent]];
					}
				}
			}

//			NSLog(@"path Mutable =%@", boardMutableString);
			[self pasteString:boardMutableString];
			flag = YES;
		}
    }
}

- (void)pasteString:(NSString *)boardString {
    NSPasteboard *board = [NSPasteboard generalPasteboard];
	NSArray *array;
	
	// Nbv{[hɃRs[
	array = [NSArray arrayWithObject:NSStringPboardType];
	[board declareTypes:array owner:nil];
	[board setString:boardString forType:NSStringPboardType];
}

- (IBAction)stripUrlAction:(id)sender {
	NSAttributedString *attrStr;
	unsigned int length;
	NSRange aRange;
	int i;
	NSURL *url;
    NSPasteboard *board = [NSPasteboard generalPasteboard];
	NSArray *array;
	NSString *type;
	NSString *urlString = @"", *urlAbsoluteString;
	int arrayCount = 0;
	BOOL flag = NO;
	NSMutableString *boardMutableString;

	array = [board types];
	arrayCount = [array count];

	boardMutableString = [NSMutableString string];

	for (i=0; i<arrayCount; i++) {
		type = [array objectAtIndex:i];      

		if (([type isEqualToString:@"NeXT RTFD pasteboard type"] == YES) && (flag == NO)) {
			attrStr = [[NSAttributedString alloc] initWithRTFD:[board dataForType:@"NeXT RTFD pasteboard type"] documentAttributes:NULL]; 
			length = [attrStr length];

			aRange = NSMakeRange(0, 0);
	
			for (i=0; i<length; i++) {
				url = [attrStr attribute:NSLinkAttributeName atIndex:i effectiveRange:&aRange];

				if (url != nil) {
					urlAbsoluteString = [url absoluteString];
					if ([urlString isEqualToString:urlAbsoluteString] == NO) {
						[boardMutableString appendFormat:@"%@\n",urlAbsoluteString];
						urlString = urlAbsoluteString;
//						NSLog(@"%d %@", i, url);
						flag = YES;
					}
				}
			}
		} else if (([type isEqualToString:@"NeXT Rich Text Format v1.0 pasteboard type"] == YES) && (flag == NO)) {
			attrStr = [[NSAttributedString alloc] initWithRTF:[board dataForType:@"NeXT Rich Text Format v1.0 pasteboard type"] documentAttributes:NULL]; 
			length = [attrStr length];

			aRange = NSMakeRange(0, 0);
	
			for (i=0; i<length; i++) {
				url = [attrStr attribute:NSLinkAttributeName atIndex:i effectiveRange:&aRange];

				if (url != nil) {
					urlAbsoluteString = [url absoluteString];
					if ([urlString isEqualToString:urlAbsoluteString] == NO) {
						[boardMutableString appendFormat:@"%@\n",urlAbsoluteString];
						urlString = urlAbsoluteString;
//						NSLog(@"%d %@", i, url);
						flag = YES;
					}
				}
			}
		}
	}

	if (flag == YES) {
		[self pasteString:boardMutableString];
	}
}

- (IBAction)stripStringRTFAction:(id)sender {
	NSAttributedString *attrStr;
	int i;
    NSPasteboard *board = [NSPasteboard generalPasteboard];
	NSArray *array;
	NSString *type;
	int arrayCount = 0;
	BOOL flag = NO;
	NSMutableString *boardMutableString;

	array = [board types];
	arrayCount = [array count];

	boardMutableString = [NSMutableString string];

	for (i=0; i<arrayCount; i++) {
		type = [array objectAtIndex:i];      

		if (([type isEqualToString:@"NeXT RTFD pasteboard type"] == YES) && (flag == NO)) {
			attrStr = [[NSAttributedString alloc] initWithRTFD:[board dataForType:@"NeXT RTFD pasteboard type"] documentAttributes:NULL]; 

			[boardMutableString appendString:[attrStr string]];
			flag = YES;
		} else if (([type isEqualToString:@"NeXT Rich Text Format v1.0 pasteboard type"] == YES) && (flag == NO)) {
			attrStr = [[NSAttributedString alloc] initWithRTF:[board dataForType:@"NeXT Rich Text Format v1.0 pasteboard type"] documentAttributes:NULL]; 

			[boardMutableString appendString:[attrStr string]];
			flag = YES;
		}
	}

	if (flag == YES) {
		[self pasteString:boardMutableString];
	}
}

@end
